'GeoScript: Demostracin de secciones cnicas

'A HACER: Explicaciones ms detalladas de las construcciones (con dibujos).

TITLE "Secciones Cnicas"
SCREEN 760,600
SPEED 300

CLS 0
WINDOW 760,380
CONSTRUCT PrincipalTitulo FAST
CONSTRUCT Instrucciones
TEXTWINDOW 100,520, 550,20
TEXT "Haz clic en 'Continuar' o presiona [Enter] para continuar.", &HFFFFFF, 0
ANIMATE aTitulo FAST
'WAIT no es necesario aqu, la ANIMATION espera cuando termina.

'Restauramos el ttulo porque desaparece despus de que termine la ANIMATION.
  MARKPOINT Secciones, 64
  MARKPOINT Cnicas, 64

WINDOW 760,600
'Restauramos el texto porque el WINDOW ms grande lo cubri:
CONSTRUCT Instrucciones

MENU
MENUITEM "Demostracin general (estereomtrica) de secciones cnicas"
  CLS
  CONSTRUCT InitSections FAST
  fillP = COPY LabajoL
  CONSTRUCT LlenarCono FAST puntaL, LabajoL, RabajoL
  fillP = COPY LabajoR
  CONSTRUCT LlenarCono FAST puntaR, LabajoR, RabajoR
  fillLine1 = ILINEPOLAR puntaB, gridX, 180
  fillLine2 = COPY fillLine1
  CONSTRUCT LlenarConoCirculo FAST
  IPOINT C 260,160, 4,(255,0,0), 8
  cutPCircle = ICIRCLE lineCenter, C
  TEXTWINDOW 400,350, 300,130
  TEXT "Demostracin general de secciones cnicas", &HD0D000, -1, 32
  TEXTWINDOW 400,480, 300,200
  TEXT "Cuando termine la animacin, arrastra el punto C (marcado con rojo) que aparecer en el cono superior izquierdo, para cambiar la inclinacin del plano de corte."
  WAIT
  INTERACT hacerSeccion PACE

MENUITEM "Cnicas (en general) como proyeccin central de un crculo"
  CLS &H603000
  TEXTWINDOW 150,150, 500,90
  TEXT "Cnicas (en general) como proyeccin central de un crculo", &HFFFF80, &H603000, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "Puesto que un cono se forma por rectas desde un punto hacia un circunferencia, todas las secciones cnicas pueden interpretarse como proyecciones centrales de un crculo. La construccin siguiente visualiza esta propiedad.", &HFFFF80, &H603000
  TEXTWINDOW 150,340, 450,200
  TEXT "Arrastra el punto C (marcado con rojo) para cambiar el centro de la proyeccin. - Arrastra el punto B (tambin rojo) para cambiar la ubicacin y el tamao del crculo.", &HFFFF80, &H603000
  MENU
  MENUITEM "Mostrar construccin repetida"
    CLS &H603000
    IPOINT C 300,40, 4, &HFF4040, 6
    IPOINT center 300,140
    IPOINT B 350,140, 4, &HFF4040, 6
    LINE proyLine 0,200, 760,200, -1, &H80C0FF
    LINE centerLine 300,0, 300,600, 1, &H80C0FF
    INTERACT iCentralRepeated PACE
  MENUITEM "Mostrar animacin"
    CLS &H603000
    IPOINT C 300,40, 4, &HFF4040, 6
    IPOINT center 300,140
    IPOINT B 350,140, 4, &HFF4040, 6
    LINE proyLine 0,200, 760,200, -1, &H80C0FF
    LINE centerLine 300,0, 300,600, 1, &H80C0FF
    INTERACT iCentral PACE
  ENDMENU

MENUITEM "Construccin de una seccin cnica desde 5 puntos"
  CLS &HFFE0C0
  TEXTWINDOW 150,150, 450,90
  TEXT "Construccin de una seccin cnica desde 5 puntos", &H806040, &HFFE0C0, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "Una seccin cnica es definida por cinco puntos. La siguiente demostracin construye una seccin cnica desde cinco puntos dados. Se basa en el teorema de Pascal: 'Si las intersecciones de tres pares de lados opuestos de un hexgono (irregular) se encuentran en una recta, entonces las seis vrtices se encuentran en una seccin cnica.' - Entonces, si tenemos cinco puntos (un pentgono), se puede construir la interseccin de un par de lados opuestos. Una recta trazado por este punto define las intersecciones de los otros dos pares; y estas intersecciones a su vez definen los dos lados del hexgono que faltan.", -1, &HFFE0C0
  TEXTWINDOW 150,440, 450,200
  TEXT "Arrasta los cinco puntos al lugar que deseas; despus haz clic en 'Salir' o presiona [Esc] para empezar la construccin.", -1, &HFFE0C0
  MENU
  MENUITEM "Mostrar construccin repetida"
    CLS &HFFE0C0
    CLS &HFFE0C0
    CONSTRUCT Start5 FAST
    CALL i5Repeated PACE
  MENUITEM "Mostrar animacin"
    CLS &HFFE0C0
    CONSTRUCT Start5 FAST
    CALL iConic5 PACE
  ENDMENU

MENUITEM "Elipse como proyeccin paralela de un crculo"
  CLS &HFFC0C0
  TEXTWINDOW 150,150, 450,90
  TEXT "Elipse como proyeccin paralela de un crculo", &HE00000, &HFFC0C0, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "Una elipse puede interpretarse como una proyeccin proporcional paralela de un crculo. La construccin siguiente lo ilustra.", 0, &HFFC0C0
  TEXTWINDOW 150,340, 450,200
  TEXT "Arrastra el punto C (marcado con rojo) verticalmente para cambiar la excentricidad de la elipse.", 0, &HFFC0C0
  MENU
  MENUITEM "Mostrar construccin repetida"
    CLS &HFFC0C0
    IPOINT C 300,140, 4, &HE00000, 6
    INTERACT iElipseRepetido PACE
  MENUITEM "Mostrar animacin"
    CLS &HFFC0C0
    IPOINT C 300,140, 4, &HE00000, 6
    INTERACT iElipse PACE
  ENDMENU

MENUITEM "La 'Elipse del jardinero'"
  CLS &H00C000
  TEXTWINDOW 150,150, 450,90
  TEXT "La 'Elipse del jardinero'", &HE0FFC0, &H00C000, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "Esta construccin se llama as porque uno puede fcilmente realizarla en un jardn, con una cuerda atada a dos estacas (los dos focos de la elipse). Se basa en la propiedad de la elipse, de que desde cada punto de su circunferencia, la suma de las distancias hacia los dos focos es la misma.", &HFFFFFF, &H00C000
  TEXTWINDOW 150,340, 450,200
  TEXT "Arrastra el punto C (marcado con rojo) horizontalmente para cambiar la excentricidad de la elipse.", &HFFFFFF, &H00C000
  MENU
  MENUITEM "Mostrar construccin repetida"
    CLS &H00C000
    IPOINT C 545,240, 4, &HE00000, 6      'Init. Endpoint of axis
    INTERACT iJardineroRepetido PACE
  MENUITEM "Mostrar animacin"
    CLS &H00C000
    IPOINT C 545,240, 4, &HE00000, 6      'Init. Endpoint of axis
    INTERACT iJardinero PACE
  ENDMENU

MENUITEM "Parabola balstica"
  CLS &HA0E0FF
  TEXTWINDOW 150,150, 450,90
  TEXT "Una parbola balstica", &H808000, &HA0E0FF, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "Parbolas pueden observarse como la forma que asume una cuerda floja atada en dos extremos; y como la trayectoria ideal de un objeto tirado al aire, si no existiera la resistencia del aire. La velocidad horizontal de un tal objeto es constante, y la aceleracin de su velocidad vertical es constante. La construccin siguiente demuestra esto en una aproximacin paso a paso.", &H808000, &HA0E0FF
  TEXTWINDOW 150,370, 450,200
  TEXT "Arrastra el punto V para cambiar la velocidad vertical inicial, y el punto A para cambiar la aceleracin.",  &H808000, &HA0E0FF
  MENU
  MENUITEM "Mostrar construccin repetida"
    CLS &HA0E0FF
    IPOINT show0, 740,500
    IPOINT V, 740, 300, 10, &HFF0000, 20
    IPOINT A, 740, 510, 11, &HFFFF00, 20
    v = ILINE show0, V
    INTERACT iBalisticaRepetido PACE
  MENUITEM "Mostrar animacin"
    CLS &HA0E0FF
    IPOINT show0, 740,500
    IPOINT V, 740, 300, 10, &HFF0000, 20
    IPOINT A, 740, 510, 11, &HFFFF00, 20
    v = ILINE show0, V
    INTERACT iBalistica PACE
  ENDMENU

MENUITEM "Parbola entre el foco y la directriz"
  CLS 0
  TEXTWINDOW 150,150, 450,90
  TEXT "Una parbola entre su foco y su directriz", &HFFFF00, 0, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "La siguiente construccin se basa en la propiedad de la parbola, de que desde todos sus puntos, la distancia hacia un punto dado (el foco) es igual a la distancia hacia una recta dada (la directriz).", &HFFFFFF, 0
  TEXTWINDOW 150,340, 450,200
  TEXT "Arrastra el foco P para cambiar la forma de la parbola.", &HFFFFFF, 0
  MENU
  MENUITEM "Mostrar construccin repetida"
    CLS 0
    LINE guide, 40,0, 40,580, -1, &HFFFFFF
    IPOINT P, 100,280, -1, &HFFFFFF
    INTERACT iParabolaRepetido PACE
  MENUITEM "Mostrar animacin"
    CLS 0
    LINE guide, 40,0, 40,580, -1, &HFFFFFF
    IPOINT P, 100,280, -1, &HFFFFFF
    INTERACT iParabola PACE
  ENDMENU

MENUITEM "Hiprbola con paralelogramos de la misma rea"
  CLS &H0000FF
  TEXTWINDOW 150,150, 500,90
  TEXT "Construccin de una hiprbola por medio de paralelogramos", &HFFFF00, &H0000FF, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "La siguiente construccin se basa en la propiedad de la hiprbola, de que todos los paralelogramos paralelos a las asintotas, entre el centro y cualquier punto de la hiprbola, tienen la misma rea.", &HE0E0FF, &H0000FF
  TEXTWINDOW 150,340, 450,200
  TEXT "Arrastra el punto B (marcado en rojo) para cambiar la inclinacin de la asintota, o el punto C (tambin rojo) para cambiar el tamao del paralelogramo.", &HE0E0FF, &H0000FF
  MENU
  MENUITEM "Mostrar construccin repetida"
    CLS &H0000FF
    IPOINT B, 300,140, 4, &HE00000, 6
    IPOINT C, 420,180, 4, &HE00000, 6
    ILINE horizontal 300,140, 600,140
    INTERACT iHiperbolaRepetido PACE
  MENUITEM "Mostrar animacin"
    CLS &H0000FF
    IPOINT B, 300,140, 4, &HE00000, 6
    IPOINT C, 420,180, 4, &HE00000, 6
    ILINE horizontal 300,140, 600,140
    INTERACT iHiperbola PACE
  ENDMENU

MENUITEM "'Hiprbola del jardinero'"
  CLS &H00C000
  TEXTWINDOW 150,150, 450,90
  TEXT "La 'Hiprbola del jardinero'", &HE0FFC0, &H00C000, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "De hecho, esta expresin no existe; pero se puede construir una hiprbola de una manera muy parecida a la 'Elipse del jardinero'. La nica diferencia es que en una hiprbola no es la suma, sino la diferencia de las distancias hacia los dos focos que es constante. Entonces no sera muy difcil inventar un aparato con dos cuerdas y dos estacas para dibujar una hiprbola, de manera similar a la 'Elipse del jardinero'.", &HFFFFFF, &H00C000
  TEXTWINDOW 150,400, 450,200
  TEXT "Arrastra el punto C (marcado con rojo) horizontalmente para cambiar la diferencia entre las distancias.", &HFFFFFF, &H00C000
  MENU
  MENUITEM "Mostrar construccin repetida"
    CLS &H00C000
    IPOINT C 540,240, 4, &HE00000, 6
    INTERACT iGardenerHRepeated PACE
  MENUITEM "Mostrar animacin"
    CLS &H00C000
    IPOINT C 540,240, 4, &HE00000, 6
    INTERACT iGardenerH PACE
  ENDMENU

MENUITEM "Salir del programa"
  EXITMENU
REPEATMENU

END

'************** TITULO PRINCIPAL *********************************

CONSTRUCTION PrincipalTitulo
  IPOINT A,380,60
  IPOINT B,180,360
  IPOINT C,580,360
  fillP = COPY B
  CALL LlenaConoAzul FAST A,B,C
  IPOINT Secciones 100,220, 1,&HE0E000
  IPOINT Cnicas 600,220, 1,&HE0A000
  ICIRCLE c1 225,220,125
  ICIRCLE c2 475,220,125
REPEAT

CONSTRUCTION LlenaConoAzul punta, lAbajo, rAbajo
'Needs fillP initialized to lAbajo
  baseline = ILINE lAbajo, rAbajo
  FILL fillP, punta, rAbajo, (0,0,255), 20
  fillP = IADVANCEON fillP, baseline, 20
REPEAT 20

ANIMATION aTitulo
  STEP Secciones ALONG c1 -20
  STEP Cnicas ALONG c2 -20
  MARKPOINT Secciones, 64
  MARKPOINT Cnicas, 64
REPEAT 42

CONSTRUCTION Instrucciones
  TEXTWINDOW 100,380,500,40
  TEXT "Instrucciones generales:", &HFFFF00, 0, 32
  TEXTWINDOW 100,420, 550,65
  TEXT "Todas las demostraciones siguientes muestran construcciones animadas o repetidas. Cuando termine una construccin, haz clic en 'Continuar' o presiona la tecla [Enter]. Entonces puedes arrastrar ciertos puntos (marcados en rojo) para cambiar la apariencia de la construccin, o hacer clic en 'Salir' resp. presionar [Esc] para volver al men." &HFFFFFF, 0
REPEAT

'************ DEMOSTRACION GENERAL DE SECCIONES CONICAS **************

INTERACTION hacerSeccion
  CLICKABLE C ALONG cutPCircle
  CONSTRUCT HacerLineaCorte FAST
  IPOINT mP 160,275  ', 2, (0,0,128), 3
  ANIMATE Section FAST
REPEAT  

ANIMATION Section
  STEP mP ALONG cBase, 2
  TRACE RP, BP
  CONSTRUCT PuntoSeccion
REPEAT 471           'Permetro de cBase = 942.5

CONSTRUCTION HacerLineaCorte
  cutLine = ILINE lineCenter, C
  cAux = ICIRCLE lineCenter, C
  cutP2, dummy = ICROSS cutLine, cAux
  cutLine = LINE cutP2, C, -1, 0, 3
  MARKPOINT C
REPEAT

CONSTRUCTION LlenarCono punta, lAbajo, rAbajo
'Para rellenar un cono con gradiente.
'Necesita fillP inicializado a lAbajo
  baseline = ILINE lAbajo, rAbajo
  FILL fillP, punta, rAbajo, (255,255,128), 1
  fillP = IADVANCEON fillP, baseline, 20
REPEAT 14

CONSTRUCTION LlenarConoCirculo
'Needs fillLine1, fillLine2 initialized
  fillLine1 = ILINEPOLAR puntaB, fillLine1, 15
  fillLine2 = ILINEPOLAR puntaB, fillLine2, -15
  cFill = IARC fillLine1, fillLine2, 150
  FILL cFill, (255,255,128), 1
REPEAT 11

CONSTRUCTION InitSections
  IPOINT gridM 440,265
  LINEPOLAR gridX, 440,265, 0, -1,(128,128,128)
  LINEPOLAR gridY, 440,265, 270, -1,(128,128,128)  'tiene que ir hacia ABAJO
  IPOINT puntaL 160,5
  POINT puntaB 160,425, 1
  IPOINT puntaR 600,5
  IPOINT LabajoL 10,255
  IPOINT RabajoL 310,255
  IPOINT LabajoR 450,255
  IPOINT RabajoR 750,255
  guideTop = LINE puntaL, puntaR, &H3333, (192,192,192)
  guideAbajo = LINE RabajoL, LabajoR, &H3333, (192,192,192)
  LINE bGuideTop 160,275, 440,275, &H3333, (192,192,192)
  LINE bGuideM 160,425, 440,425, &H3333, (192,192,192)
  LINE bGuideAbajo 160,575, 440,575, &H3333, (192,192,192)
  LINE vGuideLL 10,255, 10,425, &H3333, (192,192,192)
  vGuideLM = LINE puntaL, puntaB, &H3333, (192,192,192)
  LINE vGuideLR 310,255, 310,425, &H3333, (192,192,192)
  LINE vGuideRL 450,255, 450,265, &H3333, (192,192,192)
  LINE vGuideRM 600,5, 600,265, &H3333, (192,192,192)
  LINE vGuideRR 750,255, 750,265, &H3333, (192,192,192)
  CIRCLE cGuideL 440,265, 10, (192,192,192),1, 270, 360
  CIRCLE cGuideL 440,265, 160, (192,192,192),1, 270, 360
  CIRCLE cGuideL 440,265, 310, (192,192,192),1, 270, 360
  LsideL = LINE puntaL, LabajoL
  RsideL = LINE puntaL, RabajoL
  LsideR = LINE puntaR, LabajoR
  RsideR = LINE puntaR, RabajoR
  baseL = LINE LabajoL, RabajoL
  baseR = LINE LabajoR, RabajoR
  CIRCLE cBase 160,425,150
  IPOINT lineCenter 110,170
REPEAT

CONSTRUCTION PuntoSeccion
'mP = punto que se mueve en el crculo. RP = punto resultado en la seccin.
  radiusB = LINE puntaB, mP, -1, (0,0,128)
  vertical = ILINEPOLAR mP, gridY, 0
  baseLP = ICROSS vertical, baseL
  vertical = LINE mP, baseLP, -1, (192,192,255)
  radiusL = LINE puntaL, baseLP, -1, (0,0,128)
  LP = CROSS radiusL, cutLine, 2, (0,0,128), 3
  vertical2 = ILINEPOLAR LP, gridY, 0
  BP = CROSS vertical2, radiusB, 1, (192,0,0)
  vertical2 = LINE LP, BP, -1, (192,192,255)

  onX = ICROSS vertical2, gridX
  aux = ILINE BP, onX
  auxX = ILINEPOLAR onX, aux, 270
    'auxX es como gridX, pero con su vector invertido si P est por ENCIMA de gridX !!
  pGuideB = ILINEPOLAR BP, gridX, 0
  pGuideY = ICROSS pGuideB, gridY
  pGuideB = LINE BP, pGuideY, -1, (192,192,255)
  pcGuide = CIRCLE gridM, pGuideY, (192,192,255),1, 270, 360
  dummy, pGuideR = ICROSS pcGuide, auxX
      'para seleccionar el punto correcto aun si P est por ENCIMA de gridX.
  verticalR = ILINEPOLAR pGuideR, gridY, 0
  horizontal = ILINEPOLAR LP, gridX, 0
  RP = CROSS verticalR, horizontal, 1, (0,0,128)
  verticalR = LINE pGuideR, RP, -1, (192,192,255)
  horizontal = LINE LP, RP, -1, (192,192,255)
  P = COPY LP
  MARKPOINT P    'para tener una etiqueta "P" en los otros conos tambin.
  P = COPY RP
  MARKPOINT P
  P = COPY BP
  MARKPOINT P
REPEAT

'*************** CONICAS EN GENERAL: PROYECCION CENTRAL DE UN CIRCULO ******

CONSTRUCTION InitCentral
  cLine = ILINEPOLAR B, proyLine, 0
  center = ICROSS cLine, centerLine
  c1 = CIRCLE center, B, &H80C0FF
  MARKPOINT B
  MARKPOINT C
  y = ILINEPOLAR center, proyLine, 90.5
    'no exactamente 90: la construccin no funciona all.
  dummy, P = ICROSS c1, y
REPEAT

INTERACTION iCentral
  CLICKABLE B, C
  CALL InitCentral FAST
  ANIMATE aCentral FAST
REPEAT

ANIMATION aCentral
'no STEP here; we move P as in the repeated CONSTRUCTION.
  TRACE endP
  CALL centralPoint FAST    
  y = ILINEPOLAR center, y, 1.5
  dummy, P = ICROSS c1, y, -1, &H406080
REPEAT 241

INTERACTION iCentralRepeated
  CLICKABLE B, C
  CALL InitCentral FAST
  CALL centralPoint FAST    'once, to define the first endP
  CALL aCentralRepeated
REPEAT

ANIMATION aCentralRepeated
  CALL Central PACE
REPEAT

CONSTRUCTION Central
  oldEndP = COPY endP
  y = ILINEPOLAR center, y, 5
  dummy, P = ICROSS c1, y
  CALL centralPoint FAST
  result = LINE oldEndP, endP, -1, &HFFFF40, 3
REPEAT 73  

CONSTRUCTION centralPoint
  MARKPOINT P
  radius = ILINE C, P
  A = ICROSS radius, proyLine
  radius = LINE C, A, -1, &HA00000
  rLine = ILINEPOLAR P, proyLine, 90
  D = ICROSS rLine, proyLine
  rLine = LINE P,D, -1, &HA00000
  rLine2 = ILINEPOLAR A,proyLine, 90
  endline = ILINE C,D
  endP = ICROSS rLine2, endline, 4, &HFFFF40, 3
  rLine2 = LINE A,endP, -1, &HA00000
  endline = LINE C,endP, -1, &HA00000
REPEAT

'************* Cnica desde 5 puntos (Teorema de Pascal) ***************

CONSTRUCTION Start5
  IPOINT A, 100,100, 4,&HFF0000,6
  IPOINT B, 130,150, 4,&HFF0000,6
  IPOINT C, 200,160, 4,&HFF0000,6
  IPOINT D, 230,140, 4,&HFF0000,6
  IPOINT E, 240,100, 4,&HFF0000,6
  ILINE x 0,0, 600,0
REPEAT

CONSTRUCTION Init5
  l1 = LINE A,B, -1, &HFFFFFF
  l2 = LINE D,E, -1, &HFFFFFF
  S = ICROSS l1, l2, 1
  MARKPOINT S
  l1 = LINE A,S, -1, &HFFFFFF
  l2 = LINE D,S, -1, &HFFFFFF
  l1 = ILINE C,D
  l2 = ILINE B,C
  'Alargamos l1 y l2 por 500 pxeles hacia ambos lados
  ICIRCLE limiter 0,0,500
  IMOVECIRCLE limiter, C
  P1,P2 = ICROSS limiter, l1
  P3,P4 = ICROSS limiter, l2
  l1 = LINE P1,P2, -1, &HFFFFFF
  l2 = LINE P3,P4, -1, &HFFFFFF
  MARKPOINT A
  MARKPOINT B
  MARKPOINT C
  MARKPOINT D
  MARKPOINT E
REPEAT

INTERACTION iInit5
  CLICKABLE A,B,C,D,E
  CALL Init5 FAST
REPEAT

CONSTRUCTION Point5
  S1 = ICROSS g, l1
  S2 = ICROSS g, l2
  s1 = LINE S1, A, -1, &HC0C0FF
  s2 = LINE S2, E, -1, &HC0C0FF
  P = CROSS s1,s2, 4,&H0000FF,2
  s1 = LINE S1, P, -1, &HC0C0FF
  s2 = LINE S2, P, -1, &HC0C0FF
REPEAT

ANIMATION aConic5
  TRACE P
  CALL Point5 FAST
  g = LINEPOLAR S,g, 0.3, -1, &HFF80FF
REPEAT 600    'la recta necesita girar solamente 180

'INTERACTION iConic5
ANIMATION iConic5
  CALL iInit5 FAST
  CALL Init5 FAST   'otra vez, para restaurar la construccin en la pantalla
  g = ILINEPOLAR S,x,0
  CALL aConic5 FAST
REPEAT 32000

CONSTRUCTION Repeated5
  oldP = COPY P
  g = LINEPOLAR S,g, 3, -1, &HFF80FF
  CALL Point5
  result = LINE oldP, P, -1, &H0000FF, 2
REPEAT 61

ANIMATION i5Repeated
  CALL iInit5 FAST
  CALL Init5 FAST   'otra vez, para restaurar la construccin en la pantalla
  g = ILINEPOLAR S,x,0
  CALL Point5 FAST  'para inicializar el primer P
  CALL Repeated5 PACE
  WAIT
REPEAT 32000

'************* Elipse como proyeccin de un crculo ******************

CONSTRUCTION InitElipse
  POINT Center 300,280
  LINEPOLAR axis 300,280, 0
  LINEPOLAR vAxis 300,280, 90
  CIRCLE c1 300,280, 240
  c2 = CIRCLE Center, C
  MARKPOINT C
  POINT P 300,40     'el punto que se mueve alrededor del crculo
  oldP3 = COPY C
REPEAT

INTERACTION iElipse
  CLICKABLE C ALONG vAxis
  CONSTRUCT InitElipse FAST
  ANIMATE aElipse FAST
REPEAT

INTERACTION iElipseRepetido
  CLICKABLE C ALONG vAxis
  CONSTRUCT InitElipse FAST
  CALL aElipseRepetido FAST
REPEAT

ANIMATION aElipseRepetido
  CONSTRUCT Elipse PACE
REPEAT

CONSTRUCTION Elipse
  radius = LINE Center, P, -1, &HFFFFFF
  newRadius = ILINEPOLAR Center, radius, 10
  dummy, P2 = ICROSS radius, c2
  vertical = ILINEPOLAR P, axis, 90
  axisP = ICROSS vertical, axis
  vertical = LINE P, axisP, -1, &HFFFFFF
  horizontal = ILINEPOLAR P2, axis, 0
  P3 = ICROSS vertical, horizontal
  horizontal = LINE P2, P3, -1, &HFFFFFF
  result = LINE oldP3, P3, -1, &HE00000, 3
  oldP3 = COPY P3
  dummy, P = ICROSS newRadius, c1
REPEAT 37

CONSTRUCTION ElipsePt   'for ANIMATION
  radius = LINE Center, P, -1, &HFFFFFF
  dummy, P2 = ICROSS radius, c2
  vertical = ILINEPOLAR P, axis, 90
  axisP = ICROSS vertical, axis
  vertical = LINE P, axisP, -1, &HFFFFFF
  horizontal = ILINEPOLAR P2, axis, 0
  P3 = CROSS vertical, horizontal, 2, &HE00000, 3
  horizontal = LINE P2, P3, -1, &HFFFFFF
REPEAT

ANIMATION aElipse
  STEP P ALONG c1 4
  TRACE P3
  CALL ElipsePt FAST
REPEAT 377   'radius 240x6.2832 = 1508

'*************** "Elipse del Jardinero" **********************

CONSTRUCTION InitJardinero
  POINT A  200,240
  POINT B  440,240
  MARKPOINT A
  MARKPOINT B
  axis = ILINE A,B
  c1 = ICIRCLE B, C
  dummy, C = ICROSS c1, axis, 4, &HE00000, 6   'Hay que asegurar que C no est entre los focos!
  MARKPOINT C
  P1 = COPY C
  P2 = COPY C
  C1 = COPY C
  C2 = COPY C
REPEAT

INTERACTION iJardinero
  CLICKABLE C ALONG axis
  CALL InitJardinero FAST
  CALL aJardineroCirculos FAST
REPEAT

INTERACTION iJardineroRepetido
  CLICKABLE C ALONG axis
  CALL InitJardinero FAST
  CALL aJardineroRepetido FAST
REPEAT

'Ponemos la construccin repetida en una ANIMATION para que tenga el mismo
'  comportamiento (para el usuario) como la ANIMATION: espera por 'Continuar'
'  despus de que termina.
ANIMATION aJardineroRepetido
  CALL JardineroCirculos PACE
REPEAT

CONSTRUCTION JardineroCirculos
'Agrandar un crculo por 15 pxeles y achicar el otro por 15 pxeles.
  cA = CIRCLE A,C1, &HC06060
  cB = CIRCLE B,C2, &HC06060
  C1 = IADVANCETO C1, A, 15
  C2 = IADVANCETO C2, A, -15
  P3, P4 = ICROSS cA, cB
  line1 = LINE P1,P3, -1, &HFFFF40
  line2 = LINE P2,P4, -1, &HFFFF40
  P1 = COPY P3
  P2 = COPY P4
REPEAT 17        'para AB = 16x15 = 240

ANIMATION aJardineroCirculos
  STEP C1, -1,0
  STEP C2, 1,0
  TRACE P1, P2
  cA = CIRCLE A,C1, &HC06060
  cB = CIRCLE B,C2, &HC06060
  P1, P2 = CROSS cA, cB, 2, &HFFFF40, 3
  part1 = LINE A,P1, -1, &H3030FF
  part2 = LINE B,P1, -1, &H3030FF
  part3 = LINE A,P2, -1, &H0000E0
  part4 = LINE B,P2, -1, &H0000E0
REPEAT 241

'************* Parbola balstica *******************************

CONSTRUCTION Balistica
'requiere inicializar x a 0, P a 20,500
  
  v = ILINE show0, V5      'para conseguir la DIRECCION de la velocidad (hacia arriba o abajo)
  x = ILINEPOLAR P,x, 0
  B = IADVANCEON P,x, 15
  x = LINE P,B, -1, &H505050
  y = ILINEPOLAR B,v, 0
  c1 = ICIRCLE show0,V5
  IMOVECIRCLE c1, B
  dummy, P2 = ICROSS c1, y
  y = LINE B, P2, -1, &H505050
  pLine = LINE P, P2, -1, &HE0E000, 3
  P = COPY P2
'Now subtract a from v
  v2 = ILINE show0, A5
  c1 = ICIRCLE show0, A5
  IMOVECIRCLE c1, V5
  dummy, V5 = ICROSS c1,v2
REPEAT 46

CONSTRUCTION BalisticaRapido
  v = ILINE show0, V5      'para conseguir la DIRECCION de la velocidad (hacia arriba o abajo)
  x = ILINEPOLAR P,x, 0
  B = ADVANCEON P,x, 15
  x = LINE P,B, -1, &H505050
  y = ILINEPOLAR B,v, 0
  c1 = ICIRCLE show0,V5
  IMOVECIRCLE c1, B
  dummy, P2 = ICROSS c1, y
  IMOVECIRCLE c1, P2         'Avanzamos P2 5 veces, para dibujar esta lnea 5 veces ms larga.
  dummy, P2 = ICROSS c1, y
  IMOVECIRCLE c1, P2
  dummy, P2 = ICROSS c1, y
  IMOVECIRCLE c1, P2
  dummy, P2 = ICROSS c1, y
  IMOVECIRCLE c1, P2
  dummy, P3 = ICROSS c1, y
  y = LINE B, P3, -1, &H505050
  t = LINE P, P3, -1, &H505050
  CALL Div5 P,P3,P2           'Ahora conseguimos el VERDADERO P2.
  P = COPY P2
'Ahora restamos a de v
  v2 = ILINE show0, A5
  c1 = ICIRCLE show0, A5
  IMOVECIRCLE c1, V5
  dummy, V5 = ICROSS c1,v2
REPEAT

ANIMATION aBalistica
  'No hay STEP aqu: P es movido a lo largo de la parbola como en la construccin repetida.
  TRACE P2
  CALL BalisticaRapido FAST
REPEAT 230

INTERACTION iBalistica
  CLICKABLE V ALONG v
  CLICKABLE A ALONG v
  CALL aPrepareBalistica FAST
  CALL aBalistica FAST
REPEAT

INTERACTION iBalisticaRepetido
  CLICKABLE V ALONG v
  CLICKABLE A ALONG v
  CALL PrepareBalistica FAST
  CALL aBalisticaRepetido
REPEAT

ANIMATION aBalisticaRepetido
  CALL Balistica PACE
REPEAT

CONSTRUCTION PrepareBalistica
  Velocidad = LINE show0, V, -1, &HFF0000, 3
  Aceleracin = LINE show0, A, -1, &HFFFF00, 3
  MARKNUMBERLINE Velocidad, 5
  MARKNUMBERLINE Aceleracin, 5
  MARKPOINT V
  MARKPOINT A, -1, 2
  CALL Div5 FAST show0,V,V5
  CALL Div5 FAST show0,A,A5
  ILINEPOLAR x, 0,0,0
  IPOINT P 20,500
REPEAT

CONSTRUCTION aPrepareBalistica
  CALL PrepareBalistica
    'Ahora ajustamos la velocidad y la aceleracin para conseguir la misma
    'parbola como en la construccin repetida, pero con pasos 5 veces ms finos:
    '  a2 = a1/25, v2 = v1/5
  CALL Div5 FAST show0, A5, A5
  CALL Div5 FAST show0, A5, A5
  CALL Div5 FAST show0, V5, V5
REPEAT

CONSTRUCTION Div5 A,B,C
  'Divide AB entre 5 y devuelve el resultado en AC; invisible.
  mainLine = ILINE A,B
  rLine = ILINEPOLAR A, mainLine, 90
  D = IADVANCEON A, rLine, 100
  BB = IADVANCEON A, rLine, 500
  rLine = ILINE BB, B
  pLine = ILINEPOLAR D, rLine, 0
  C = ICROSS pLine, mainLine, 4, &HE0E000, 3
    'Le damos un estilo y un color; se usa para TRACE P2.
REPEAT

'************* Parbola: entre foco y directriz ****************

CONSTRUCTION InitParabola
  MARKPOINT P
  rLine = ILINEPOLAR P, guide, 90
  R = ICROSS rLine, guide
  M1 = IMIDDLE P,R
  M2 = COPY M1
  P1 = COPY M1
  P2 = COPY M1
REPEAT

INTERACTION iParabola
  CLICKABLE P
  CALL InitParabola FAST
  CALL aParabola FAST
REPEAT

INTERACTION iParabolaRepetido
  CLICKABLE P
  CALL InitParabola FAST
  CALL aParabolaRepetido FAST
REPEAT

ANIMATION aParabolaRepetido
  CALL Parabola PACE
REPEAT

ANIMATION aParabola
  STEP M1, -2,0
  STEP M2, 2,0
  TRACE P3,P4
  CALL ParabolaPrincipal
  CALL ParabolaAuxLines P3
  CALL ParabolaAuxLines P4
REPEAT 300

CONSTRUCTION Parabola
  c1 = CIRCLE P,M1, &H808080
  parallel = LINEPOLAR M2, guide, 0, -1, &H808080
  P3, P4 = ICROSS c1, parallel
  line1 = LINE P1,P3, -1, &HFF3030
  line2 = LINE P2,P4, -1, &HFF3030
  P1 = COPY P3
  P2 = COPY P4
  M1 = IADVANCETO M1, P, -15
  M2 = IADVANCETO M2, R, -15
REPEAT 45

CONSTRUCTION ParabolaPrincipal
  c1 = CIRCLE P,M1, &H808080
  parallel = LINEPOLAR M2, guide, 0, -1, &H808080
  P3, P4 = CROSS c1, parallel, 2, &HFF3030, 3
  part3 = LINE P,P4, -1,&HC0C000
REPEAT

CONSTRUCTION ParabolaAuxLines P1
  rLine = ILINEPOLAR P1, guide, 90
  R = ICROSS rLine, guide
  a = LINE P,P1, -1,&HE0E000
  b = LINE P1,R, -1, &HE0E000
  MARKNUMBERLINE a, 10
  MARKNUMBERLINE b, 10
  union = LINE P,R, &HF0F0, &H00E000
  mid = MIDLINE P,R, &HF0F0, &H00E000
REPEAT

'************* Hiprbola: paralelogramos de la misma rea **********

CONSTRUCTION InitHiperbola
  IPOINT Center 300,300
  IPOINT A, 500,300
  MARKPOINT B
  D = IADVANCETO Center, A, 800    'para alargar la recta
  E = IADVANCETO Center, A, -800
  asym1 = LINE E,D, -1, &HFFFF00, 2
  D = IADVANCETO Center, B, 800
  E = IADVANCETO Center, B, -800
  asym2 = LINE E,D, -1, &HFFFF00, 2
  c1 = ICIRCLE Center, C
  b = IBISECTOR asym1, asym2
  dummy, C = ICROSS c1, b, 4, &HE00000, 6
        'C = punto final del paralelogramo. Hay que asegurar que est en el medio entre los ejes.
  MARKPOINT C
  side1 = ILINEPOLAR C, asym2, 0
  Cross1 = ICROSS side1, asym1
  side1 = LINE Cross1, C, -1, &HC0C0C0
  side2 = ILINEPOLAR C, asym1, 0
  Cross2 = ICROSS side2, asym2
  side2 = LINE Cross2, C, -1, &HC0C0C0
  s = ILINE Center, Cross1, -1, &HC0C0C0
  MARKLINE s, -1, 1
  IPOINT Cross3, 765,300   'init. punto final del paralelogramo en asym1
REPEAT

CONSTRUCTION HiperbolaPrincipal   'para la ANIMATION
  CALL HiperbolaPoint FAST
  parallel = ILINEPOLAR Cross3, asym2, 0
  C2 = CROSS guide, parallel, 2, &HFF5050, 3
  parallel2 = ILINEPOLAR C2, asym1, 0
  Cross5 = ICROSS parallel2, asym2
  FILL Cross5, C2, Cross3, &HFFFFC0, 180
  FILL Cross5, Center, Cross3, &HFFFFC0, 180
REPEAT

CONSTRUCTION HiperbolaFirst   'sin FILL, solamente para inicializar el primer C2
  CALL HiperbolaPoint FAST
  parallel = ILINEPOLAR Cross3, asym2, 0
  C2 = CROSS guide, parallel, 2, &HFF5050, 3
  parallel2 = ILINEPOLAR C2, asym1, 0
  Cross5 = ICROSS parallel2, asym2
REPEAT

CONSTRUCTION HiperbolaPoint
  c1 = ICIRCLE Center, Cross1
  IMOVECIRCLE c1, Cross3
  dummy, Cross4 = ICROSS c1, asym1
  s = LINE Cross3, Cross4, -1, &HFF0000, 2
  MARKLINE s, Cross3, Cross4, -1, 1
  guide = ILINE Cross4, C   'no la dibujamos todava; queremos ver sta recta ms larga.
  ICIRCLE limiter 0,0,500
  IMOVECIRCLE limiter, C
  Limit1, Limit2 = ICROSS limiter, guide
  guide = LINE Limit1, Limit2, &HF8F8, &H00C0C0
     'Ahora la recta se extiende 500 pxeles por ambos lados de C.
REPEAT

CONSTRUCTION Hiperbola     'Construccin repetida
  CALL HiperbolaPoint
  parallel = LINEPOLAR Cross3, asym2, 0, -1, &HA0A000
  C3 = ICROSS guide, parallel
  parallel2 = ILINEPOLAR C3, asym1, 0
  Cross5 = ICROSS parallel2, asym2
  parallel2 = LINE C3, Cross5, -1, &HA0A000
  s = LINE Cross3, Cross4, -1, &HFFFF00, 2  'restaurar color de la asintota!
  Cross3 = ADVANCEON Cross3, asym1, -15
  hypLine = LINE C2, C3, -1, &HFF5050, 3
  C2 = COPY C3
REPEAT 52

ANIMATION aHiperbola
  STEP Cross3, -2, 0
  TRACE C2
  CALL HiperbolaPrincipal
REPEAT 383

INTERACTION iHiperbola
  CLICKABLE B ALONG horizontal
  CLICKABLE C ALONG b
  CALL InitHiperbola FAST
  ANIMATE aHiperbola FAST
REPEAT

INTERACTION iHiperbolaRepetido
  CLICKABLE B ALONG horizontal
  CLICKABLE C ALONG b
  CONSTRUCT InitHiperbola FAST
  ANIMATE aHiperbolaRepetido FAST
REPEAT

ANIMATION aHiperbolaRepetido
  CONSTRUCT HiperbolaFirst FAST  'una vez, para inicializar el primer C2!
  CONSTRUCT Hiperbola PACE
REPEAT

'*************** "Gardener Hyperbola" **********************

CONSTRUCTION InitGardenerH
'Init. focos
  POINT A  200,240
  POINT B  440,240
  MARKPOINT A
  MARKPOINT B
  axis = ILINE A,B
  MARKPOINT C
  C1 = COPY A
  C2 = COPY C
REPEAT

CONSTRUCTION InitGardenerHCircles
  cA = CIRCLE A,C1, &HC06060
  cB = CIRCLE B,C2, &HC06060
  cC = COPY cA
  cD = COPY cB
  MOVECIRCLE cC, B, &H6060C0
  MOVECIRCLE cD, A, &H6060C0
REPEAT

INTERACTION iGardenerH
  CLICKABLE C ALONG axis
  CALL InitGardenerH FAST
  CALL InitGardenerHCircles FAST
  CALL aGardenerHCircles FAST
REPEAT

INTERACTION iGardenerHRepeated
  CLICKABLE C ALONG axis
  CALL InitGardenerH FAST
  CALL aGardenerHRepeated FAST
REPEAT

ANIMATION aGardenerHRepeated
  CALL GardenerHCircles PACE
REPEAT

ANIMATION aGardenerHCircles
  STEP cA, 0,0,3
  STEP cB, 0,0,3
  STEP cC, 0,0,3
  STEP cD, 0,0,3
  TRACE P1, P2, P3, P4
  P1, P2 = CROSS cA, cB, 2, &HFFFF40, 3
  P3, P4 = CROSS cC, cD, 2, &H40FFFF, 3
REPEAT 140

CONSTRUCTION GardenerHCircles
'Agrandar ambos crculos por 10 pxeles
  C1 = IADVANCEON C1, axis, -10
  C2 = IADVANCETO C2, B, -10
  cA = CIRCLE A,C1, &HC06060
  cB = CIRCLE B,C2, &HC06060
  P3, P4 = ICROSS cA, cB
'Aqu hay un error extrao. Las primeras de las siguientes lneas no fueron dibujadas;
'  pero solamente en estos crculos (a la izquierda).
'  En los crculos celestes a la derecha (instrucciones ms abajo), se dibujan correctamente.
  line1 = LINE P1,P3, -1, &HFFFF40
  line2 = LINE P2,P4, -1, &HFFFF40
  P1 = COPY P3
  P2 = COPY P4
  MOVECIRCLE cA, B, &H6060C0
  MOVECIRCLE cB, A, &H6060C0
  P7, P8 = ICROSS cA, cB
  line1 = LINE P5,P7, -1, &H40FFFF
  line2 = LINE P6,P8, -1, &H40FFFF
  P5 = COPY P7
  P6 = COPY P8
REPEAT 45
