'Demostracin de construcciones bsicas de tringulos.

TITLE "Construcciones bsicas de tringulos"
IPOINT A, 60,397
IPOINT B, 620,397
IPOINT C, 390,123
CONSTRUCT Triangulo FAST A,B,C
FILL A,B,C, (192,192,0), 200
CONSTRUCT Marco FAST

WINDOW 640,120

TEXTWINDOW 200,230, 255,120
TEXT "Construcciones bsicas de tringulos", (255,255,0), (160,0,0), 40
IPOINT A, -100,100
IPOINT B, 0,100
IPOINT C, -30,30
IPOINT D, 740,100
IPOINT E, 640,100
IPOINT F, 670,30
ANIMATE Triang FAST

WINDOW 640,400

ICIRCLE c2, 0,0, 90
ICIRCLE c3, 0,0, 70
CALL ladosTitulo FAST c2, c3
  'No podemos poner texto en una CONSTRUCTION FAST:
  '  sta actualiza los grficos solamente en REPEAT.
TEXTWINDOW 270,20, 350,300
TEXT "Problema 1: Construye un tringulo, sabiendo las medidas de los tres lados."
WAIT
'ICIRCLE c1, 0,0, 300
ICIRCLE c2, 0,0, 270
ICIRCLE c3, 0,0, 210
CALL lados SLOW c1, c2, c3

CALL ladosTituloNo FAST
TEXTWINDOW 270,20, 350,300
TEXT "Problema 2: Construye un tringulo con estas medidas de los tres lados. (Las medidas son diferentes de las del primer problema.)"
WAIT
ICIRCLE c2, 0,0, 120
ICIRCLE c3, 0,0, 90
CALL ladosNo SLOW c1, c2, c3

ICIRCLE c2, 0,0, 80
CALL AnguloDentroTitulo FAST c2
TEXTWINDOW 270,20, 350,300
TEXT "Problema 3: Construye un tringulo con las medidas de los lados b y c conocidas, y el ngulo encerrado entre estos dos lados."
WAIT
ICIRCLE c2, 0,0, 240
CALL AnguloDentro SLOW c2

CALL dosAngulosTitulo FAST
TEXTWINDOW 270,20, 350,300
TEXT "Problema 4: Construye un tringulo, dada la medida del lado c, y los ngulos en A y B."
WAIT
CALL dosAngulos SLOW

ICIRCLE c1, 0,0, 110
CONSTRUCT oppAngulo1Titulo FAST c1
TEXTWINDOW 270,20, 350,300
TEXT "Problema 5: Construye un tringulo, dadas las medidas de dos lados, y un ngulo opuesto a uno de estos lados."
WAIT
ICIRCLE c1, 0,0, 330
CONSTRUCT oppAngulo1 SLOW c1

ICIRCLE c1, 0,0, 105
CONSTRUCT oppAngulo0Titulo FAST c1
TEXTWINDOW 270,20, 350,300
TEXT "Problema 6: Construye un tringulo con estas medidas de dos lados dadas, y el ngulo opuesto a uno de estos lados. (El lado a es diferente del problema anterior.)"
WAIT
ICIRCLE c1, 0,0, 225
CONSTRUCT oppAngulo0 SLOW c1

ICIRCLE c1, 0,0, 85
CONSTRUCT oppAngulo1Titulo FAST c1  'Es el mismo procedimiento para 2 soluciones como para 1.
TEXTWINDOW 270,20, 350,300
TEXT "Problema 7: Construye un tringulo, dadas las medidas de dos lados, y el ngulo opuesto a uno de estos lados. (El lado a es otra vez diferente de los problemas anteriores. Preprate para una sorpresa.)"
WAIT
ICIRCLE c1, 0,0, 255
CONSTRUCT oppAngulo2 SLOW c1

TEXTWINDOW 170,20, 350,180
TEXT "CONCLUSION: Cuando dos tringulos coinciden en dos lados y el ngulo opuesto a uno de estos lados, entonces NO est comprobado que estn congruentes. Como viste, en este caso puede haber dos soluciones.", (255,255,0), (160,0,0), 24
WAIT
TEXTWINDOW 120,200, 400,80
TEXT "Pero en los otros casos, donde hubo una sola solucin, puedes saber que dos tringulos son congruentes:", 0, (255,255,160), 24
TEXTWINDOW 120,280, 400,80
TEXT "Cuando coinciden en todos los tres lados, o en dos lados y el ngulo encerrado entre ellos, o en un lado y dos ngulos.", 0, (255,255,160), 24
WAIT
END

'************ Titulo ANIMATION ******************
'TEXTWINDOW 200,240, 240,90

CONSTRUCTION Marco
  IPOINT A, 180,200
  IPOINT B, 457,200
  IPOINT C, 180,370
  IPOINT D, 457,370
  FILL A,B,C, (160,0,0), 255
  FILL B,C,D, (160,0,0), 255
REPEAT

ANIMATION Triang
  STEP A, 16,0
  STEP B, 16,0
  STEP C, 16,0
  STEP D, -16,0
  STEP E, -16,0
  STEP F, -16,0
  CALL Triangulo FAST A,B,C
  FILL A,B,C, (0,0,255), 40
  CALL Triangulo FAST D,E,F
  FILL D,E,F, (0,255,0), 40
REPEAT 50

CONSTRUCTION Triangulo A,B,C
  c = LINE A,B, -1, (0,0,255), 3
  b = LINE A,C, -1, (0,0,255), 3
  a = LINE B,C, -1, (0,0,255), 3
REPEAT

'*********** 3 lados dados **************************

CONSTRUCTION ladosTitulo c2, c3
  CLS
  POINT A, 20,100
  c, B = STARTLINE A, 0, 100, -1, (0,0,255)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 10
  IMOVECIRCLE c2, A
  IMOVECIRCLE c3, B
  dummy, C = ICROSS c2, c3
  MARKPOINT C
  b = LINE A,C, -1, (0,0,255)
  MARKNUMBERLINE b,A,C, 10
  a = LINE B,C, -1, (0,0,255)
  MARKNUMBERLINE a,B,C, 10, -1,1
REPEAT

CONSTRUCTION lados c1, c2, c3
  TEXTWINDOW 2,400, 636,60
  TEXT "Construimos el lado dado, c = AB.", (180,0,0)
  POINT A 140,360, -1, (255,0,0)
  c, B = STARTLINE A, 0, 300, -1, (255,0,0)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 30
  TEXT "Dibujamos un arco desde A con radio b.", (180,0,0)
  IMOVECIRCLE c2, A
  IMOVECIRCLE c3, B
  dummy, C = ICROSS c2, c3, -1, (255,0,0)
  c2 = ARC A,C,30, (190,190,190)
  TEXT "Dibujamos un arco desde B con radio a.", (180,0,0)
  c3 = ARC B,C,30, (190,190,190)
  TEXT "La interseccin de los dos arcos es el punto C.", (180,0,0)
  MARKPOINT C
  b = LINE A,C, -1, (255,0,0)
  MARKNUMBERLINE b,A,C, 30
  a = LINE B,C, -1, (255,0,0)
  MARKNUMBERLINE a,B,C, 30, -1,10
  WAIT
  TEXT ""
REPEAT

'******** 3 lados dados - imposible **************

CONSTRUCTION ladosTituloNo
  CLS
  POINT A, 20,100
  POINT B, 120,100
  POINT C, 84,52
  c = LINE A,B, -1, (0,0,255)
  b = LINE A,C, -1, (0,0,255)
  a = LINE B,C, -1, (0,0,255)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKPOINT C
  MARKNUMBERLINE c,A,B, 10
  MARKNUMBERLINE b,A,C, 20   'tenemos que 'hacer trampa' aqu y usar un factor 'equivocado'.
  MARKNUMBERLINE a,B,C, 20, -1,1
REPEAT

CONSTRUCTION ladosNo c1, c2, c3
  TEXTWINDOW 2,400, 636,60
  TEXT "Construimos el lado dado, c = AB.", (180,0,0)
  POINT A 140,360, -1, (255,0,0)
  c, B = STARTLINE A, 0, 300, -1, (255,0,0)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 30
  TEXT "Dibujamos un arco desde A con radio b.", (180,0,0)
  IMOVECIRCLE c2, A
  IMOVECIRCLE c3, B
  dummy, A2 = ICROSS c2, c
  B2, dummy = ICROSS c3, c
  c2 = ARC A,A2,30, (190,190,190)
  TEXT "Dibujamos un arco desde B con radio a.", (180,0,0)
  c3 = ARC B,B2,30, (190,190,190)
  TEXT "No hay interseccin entre los dos arcos. Es imposible construir un tringulo con estas medidas dadas.", (180,0,0)
  WAIT
  TEXT ""
REPEAT

'**************** 2 lados y el ngulo encerrado dados ************

CONSTRUCTION AnguloDentroTitulo c2
  CLS
  IPOINT A 20,100
  c, B = STARTLINE A, 0, 100, -1,(0,0,255)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 10, -1,1
  b = ILINEPOLAR A,c,40, -1,(0,0,255)
  MARKNUMBERANGLE c,b, "a"
  IMOVECIRCLE c2, A
  dummy, C = ICROSS c2, b
  c2 = ARC A,C,default, (190,190,190)
  MARKPOINT C
  b = LINE A,C, -1,(0,0,255)
  MARKNUMBERLINE b,A,C, 10
  a = LINE B,C
REPEAT

CONSTRUCTION AnguloDentro c2
  TEXTWINDOW 2,400, 636,60
  TEXT "Construimos el lado dado, c = AB.", (180,0,0)
  POINT A 140,360, -1, (255,0,0)
  c, B = STARTLINE A, 0, 300, -1, (255,0,0)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 30, -1,1
  TEXT "Dibujamos una recta desde A en al ngulo dado con el lado c.", (180,0,0)
  b = LINEPOLAR A,c,40, -1,(255,0,0)
  MARKNUMBERANGLE c,b, "a"
  TEXT "Sobre esta recta medimos la medida del lado b. As encontramos el punto C.", (180,0,0)
  IMOVECIRCLE c2, A
  dummy, C = ICROSS c2, b, -1, (255,0,0)
  c2 = ARC A,C,default, (190,190,190)
  MARKPOINT C
  MARKNUMBERLINE b,A,C, 30
  a = LINE B,C, -1, (255,0,0)
  WAIT
  TEXT ""
REPEAT

'******** 1 SIDE AND 2 AnguloS GIVEN ***************

CONSTRUCTION dosAngulosTitulo
  CLS
  IPOINT A 20,100
  c, B = STARTLINE A, 0, 100, -1,(0,0,255)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 10, -1,1
  b = ILINEPOLAR A,c,50, -1,(0,0,255)
  MARKNUMBERANGLE c,b, "a"
  REVERT c
  a = ILINEPOLAR B,c,-70, -1,(0,0,255)
  MARKNUMBERANGLE a,c, "b"
  C = CROSS a,b
  a = LINE B,C
  b = LINE A,C
  C = CROSS a,b, -1,0
  MARKPOINT C
REPEAT

CONSTRUCTION dosAngulos
  TEXTWINDOW 2,400, 636,60
  TEXT "Construimos el lado dado, c = AB.", (180,0,0)
  POINT A 140,360, -1, (255,0,0)
  c, B = STARTLINE A, 0, 300, -1, (255,0,0)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 30, -1,1
  TEXT "Dibujamos una recta desde A en al ngulo dado con el lado c.", (180,0,0)
  b = LINEPOLAR A,c,50, -1,(255,0,0)
  MARKNUMBERANGLE c,b, "a"
  TEXT "Dibujamos una recta desde B en al ngulo dado con el lado c.", (180,0,0)
  REVERT c
  a = LINEPOLAR B,c,-70, -1,(255,0,0)
  MARKNUMBERANGLE a,c, "b"
  TEXT "La interseccin de estas dos rectas es nuestro punto C.", (180,0,0)
  C = CROSS a,b, -1,(255,0,0)
  MARKPOINT C
  WAIT
  TEXT ""
REPEAT

'******** 2 lados y un ngulo opuesto dados ********************

CONSTRUCTION oppAngulo1Titulo c1
'Radio de c1 > c, solamente 1 solucin.
  CLS
  IPOINT A 20,140
  c, B = STARTLINE A, 0, 100, -1,(0,0,255)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 10, -1,1
  b = ILINEPOLAR A,c,50, -1,(0,0,255)
  MARKNUMBERANGLE c,b, "a"
  IMOVECIRCLE c1, B
  dummy, C = ICROSS c1, b
  MARKPOINT C
  b = LINE A,C
  a = LINE B,C, -1, (0,0,255)
  MARKNUMBERLINE a, 10,-1,1
REPEAT

CONSTRUCTION oppAngulo1 c1
'Radio de c1 > c, solamente 1 solucin.
  TEXTWINDOW 2,400, 636,60
  TEXT "Construimos el lado dado, c = AB.", (180,0,0)
  POINT A 140,360, -1, (255,0,0)
  c, B = STARTLINE A, 0, 300, -1, (255,0,0)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 30, -1,1
  TEXT "Dibujamos una recta desde A en al ngulo dado con el lado c.", (180,0,0)
  b = LINEPOLAR A,c,50, -1,(255,0,0)
  MARKNUMBERANGLE c,b, "a"
  TEXT "Dibujamos un arco desde B con el radio del lado conocido a.", (180,0,0)
  IMOVECIRCLE c1, B
  dummy, C = ICROSS c1, b
  c1 = ARC B,C,45
  TEXT "La interseccin de este arco con el lado b es nuestro punto C.", (180,0,0)
  MARKPOINT C
  a = LINE B,C, -1, (255,0,0)
  MARKNUMBERLINE a, 30,-1,1
  WAIT
  TEXT ""
REPEAT

CONSTRUCTION oppAngulo0Titulo c1
'Cuando el radio de c1 es demasiado pequeo y no hay solucin.
  CLS
  IPOINT A 20,140
  c, B = STARTLINE A, 0, 100, -1,(0,0,255)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 10, -1,1
  b = ILINEPOLAR A,c,50, -1,(0,0,255)
  MARKNUMBERANGLE c,b, "a"
  IMOVECIRCLE c1, B
  dummy, C = ICROSS c1, b
  MARKPOINT C
  b = LINE A,C
  a = LINE B,C, -1, (0,0,255)
  MARKNUMBERLINE a, 14,-1,1    'usamos nuevamente un factor 'equivocado'.
REPEAT

CONSTRUCTION oppAngulo0 c1
'Cuando el radio de c1 es demasiado pequeo y no hay solucin.
  TEXTWINDOW 2,400, 636,60
  TEXT "Construimos el lado dado, c = AB.", (180,0,0)
  POINT A 140,360, -1, (255,0,0)
  c, B = STARTLINE A, 0, 300, -1, (255,0,0)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 30, -1,1
  TEXT "Dibujamos una recta desde A en al ngulo dado con el lado c.", (180,0,0)
  b = LINEPOLAR A,c,50, -1,(255,0,0)
  MARKNUMBERANGLE c,b, "a"
  TEXT "Dibujamos un arco desde B con el radio del lado conocido a.", (180,0,0)
  MOVECIRCLE c1, B
  TEXT "No hay ninguna interseccin de este arco con el lado b. Es imposible construir un tringulo con estas medidas!", (180,0,0)
  WAIT
  TEXT ""
REPEAT

'Para 2 soluciones: el ttulo es igual como para 1 solucin.

CONSTRUCTION oppAngulo2 c1           '2 soluciones
  TEXTWINDOW 2,400, 636,60
  TEXT "Construimos el lado dado, c = AB.", (180,0,0)
  POINT A 140,360, -1, (255,0,0)
  c, B = STARTLINE A, 0, 300, -1, (255,0,0)
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKNUMBERLINE c,A,B, 30, -1,1
  TEXT "Dibujamos una recta desde A en al ngulo dado con el lado c.", (180,0,0)
  b = LINEPOLAR A,c,50, -1,(255,0,0)
  MARKNUMBERANGLE c,b, "a"
  TEXT "Dibujamos un arco desde B con el radio del lado conocido a.", (180,0,0)
  MOVECIRCLE c1, B
  C1, C2 = CROSS c1, b, -1,(255,0,0)
  TEXT "Hay dos intersecciones. Nuestro problema tiene dos soluciones!", (180,0,0)
  MARKPOINT C1
  MARKPOINT C2
  a1 = LINE B,C1, -1, (255,0,0)
  MARKNUMBERLINE a1, 30,-1,1
  a2 = LINE B,C2, -1, (255,0,0)
  MARKNUMBERLINE a2, 30,-1,1
  WAIT
  TEXT ""
REPEAT
