'GeoScript Tutorial No.2: DIBUJOS BASICOS CON RECTAS

'Introduciendo LINEPOLAR, CROSS, STARTLINE, ADVANCETO

'Usamos el mismo tringulo como en el Tutorial 1,
'  pero dibujaremos algunas rectas adicionales en l.
POINT A, 100,360, -1, &H0000FF
POINT B, 400,360, -1, &H0000FF
POINT C, 300,85, -1, &H0000FF
a = LINE B,C
b = LINE A,C
c = LINE A,B

'Dibujamos las alturas desde el punto C hacia el lado c,
'  y desde el punto B hacia el lado b.
'Puedes aadir un signo de grados () a los nmeros de ngulos
'  para aclarar ms el programa; pero esto es opcional.
hc = LINEPOLAR C, c, 90, &HF0F   'lnea rayada
hb = LINEPOLAR B, b, 90, &HF0F

'Sealamos el punto de interseccin con un cuadrado rojo.
H = CROSS hc, hb, 4, &HFF0000

'Inicializamos un nuevo punto y una nueva recta en otro lugar:
POINT X, 400, 280, -1, (0,128,0)
x, Y = STARTLINE X, 0, 180, -1, (0,128,0), 3    'Una recta verde, grosor 3 pxeles.

Z = ADVANCETO X, Y, 50, 2      'Un punto a 50 pxeles desde X hacia Y.

z = LINEPOLAR Z, x, 30, -1, (0,128,0), 3

WAIT
END