'GeoScript Tutorial No.5: LINEAS NOTABLES EN UN TRIANGULO; MOSTRAR TEXTO

'Introduciendo MIDDLE, MIDLINE, BISECTOR, REVERT, SCREEN, WINDOW, TEXTWINDOW, TEXT, CLS

SCREEN 600,460
'Define el tamao inicial de la ventana.
'  Si omitimos esto (como en los tutoriales anteriores),
'  la ventana se inicializar con 640x480 pxeles.

WINDOW 600, 380
'Restringe los grficos al tamao indicado.

TWINDOW 2,380, 596,60
'Especifica el marco para las instrucciones TEXT siguientes.
'Si no hay ninguna instruccin TEXTWINDOW/TWINDOW,
'  las instrucciones TEXT fracasarn.

POINT A = 70,340
POINT B = 530,340
POINT C = 140,40
c = LINE A,B
b = LINE A,C
a = LINE B,C
MARKPOINT A, -1, 2
MARKPOINT B, -1, 2
MARKPOINT C
MARKLINE a
MARKLINE b
MARKLINE c, -1, 1

TEXT "Uniremos cada punta del tringulo con el medio del lado opuesto. Las rectas resultantes se intersectan en el centro de gravedad.", (0,0,255)

D = MIDDLE B,C
E = MIDDLE A,C
F = MIDDLE A,B
d = LINE A,D, -1, (0,0,255)
e = LINE B,E, -1, (0,0,255)
f = LINE C,F, -1, (0,0,255)
G = CROSS d, e, -1, (0,0,255)
MARKPOINT G

TEXT "Presiona 'Continuar' para continuar.", (255,255,0), (160,0,0)
WAIT

TEXT "Ahora dibujaremos las mediatrices de cada lado. Ellas se intersectan en el centro de la circunferencia circunscrita del tringulo.", (255,0,0)

h = MIDLINE B,C, -1, (255,0,0)
i = MIDLINE A,C, -1, (255,0,0)
j = MIDLINE A,B, -1, (255,0,0)
M = CROSS h,i, -1, (255,0,0)
MARKPOINT M
c1 = CIRCLE M,A, (255,0,0)

TEXT "Presiona 'Continuar' para continuar.", (255,255,0), (160,0,0)
WAIT

'Borramos el contenido de la pantalla, porque ya tenemos muchas lneas en la pantalla...
CLS

'Ahora tenemos que volver a dibujar el tringulo.
c = LINE A,B
b = LINE A,C
a = LINE B,C
MARKPOINT A, -1, 2
MARKPOINT B, -1, 2
MARKPOINT C
MARKLINE a, -1, 1
MARKLINE b
MARKLINE c, -1, 1

TEXT "Dividimos cada ngulo del tringulo en la mitad. Las bisectrices se cruzan en el centro de la circunferencia inscrita.", (0,190,0)

d = BISECTOR c,b, -1, (0,190,0)
'Tenemos que invertir el vector de c, para que su origen est en B
'   y la bisectriz ser dibujada en el ngulo correcto.
REVERT c
e = BISECTOR a,c, -1, (0,190,0)
REVERT a
REVERT b
f = BISECTOR b,a, -1, (0,190,0)

M = CROSS d,e, -1, (0,190,0)
c2 = CIRCLE M, a, (0,190,0)

TEXT "Presiona 'Continuar' para continuar.", (255,255,0), (160,0,0)
WAIT

TEXT "La altura del tringulo es una recta en ngulo recto desde una punta hacia el lado opuesto. Hay tres alturas, y se intersectan en un solo punto.", (160,0,160)

hc = LINEPOLAR C,c, 90, -1, (160,0,160)
ha = LINEPOLAR A,a, 90, -1, (160,0,160)
hb = LINEPOLAR B,b, 90, -1, (160,0,160)
H = CROSS hc, ha, -1, (160,0,160)
MARKPOINT H

TEXT "Presiona 'Continuar' o 'Salir' para terminar el programa.", (255,255,0), (160,0,0)
WAIT
END