'GeoScript Tutorial No.8: EL PROCEDIMIENTO "INTERACTION"

'Introduciendo INTERACTION, CLICKABLE

WINDOW 640,420
TWINDOW 2,420, 636,40

'Ponemos la inicializacin de puntos en una CONSTRUCTION,
'de manera que podemos llamarla FAST.

CALL Init FAST

TEXT "Arrastra el punto A o B con el ratn y mira como cambia la circunferencia circunscrita. Haz clic en 'Salir' o presiona [Esc] para salir."
CALL Circum FAST
END

CONSTRUCTION Init
  POINT A = 70,340, 4, (255,0,0)
  POINT B = 530,340, 4, (255,0,0)
  IPOINT C = 140,40
REPEAT

CONSTRUCTION Triangulo A,B,C
  c = LINE A,B
  b = LINE A,C
  a = LINE B,C
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKPOINT C
  MARKLINE a
  MARKLINE b
  MARKLINE c, -1, 1
REPEAT

CONSTRUCTION Circumcirculo A,B,C
  h = MIDLINE B,C, -1, (0,0,255)
  i = MIDLINE A,C, -1, (0,0,255)
  j = MIDLINE A,B, -1, (0,0,255)
  M = CROSS h,i, -1, (0,0,255)
  MARKPOINT M
  c1 = CIRCLE M,A, (0,0,255)
REPEAT

INTERACTION Circum
  CLICKABLE A, B
  CALL Triangulo FAST A,B,C
  CALL Circumcirculo FAST A,B,C
REPEAT