'GeoScript Tutorial No.10: UN MENU

'Introduciendo MENU, MENUITEM, EXITMENU, ENDMENU, REPEATMENU

WINDOW 640,420
TWINDOW 2,420, 636,40

CALL Init FAST

MENU
  MENUITEM "Animar la construccin automticamente"
  TEXT "Todos los ngulos sobre la misma cuerda en un crculo son iguales."
    MENU
      MENUITEM "Modo FAST (animando)"
        ANIMATE MoverAngulo FAST
      MENUITEM "Modo PACE (muestra los pasos de construccin)"
        ANIMATE MoverAngulo PACE
      MENUITEM "Modo SLOW (muestra las herramientas de dibujo)"
        ANIMATE MoverAngulo SLOW
    ENDMENU
  MENUITEM "Mostrar la construccin de manera interactiva"
    TEXT "Ahora arrastra t mismo el punto P alrededor del crculo."
    MENU
      MENUITEM "Modo FAST (animando)"
        INTERACT InteractAngulo FAST
      MENUITEM "Modo PACE (muestra los pasos de construccin)"
        INTERACT InteractAngulo PACE
      MENUITEM "Modo SLOW (muestra las herramientas de dibujo)"
        INTERACT InteractAngulo SLOW
    ENDMENU
  MENUITEM "Salir del programa"
    EXITMENU
REPEATMENU
END

CONSTRUCTION Init
  CIRCLE c1, 320,200, 170, (0,0,255)
  FILL c1, (0,0,255), 20
  ILINE invisible, 0,310, 600,310
  A,B = CROSS invisible, c1
  chord = LINE A,B
  P = COPY B
REPEAT

ANIMATION MoverAngulo
  STEP P ALONG c1, 3
  MARKPOINT P
  a = LINE P,A, -1, (128,0,0)
  b = LINE P,B, -1, (128,0,0)
  MARKNUMBERANGLE a,b, "a"
REPEAT 250

INTERACTION InteractAngulo
  CLICKABLE P ALONG c1
  MARKPOINT P
  a = LINE P,A, -1, (128,0,0)
  b = LINE P,B, -1, (128,0,0)
  MARKNUMBERANGLE a,b, "a"
REPEAT