'GeoScript Tutorial No.3: MARCAR OBJETOS
'Introduciendo MARKPOINT, MARKLINE, MARKANGLE, MARKNUMBERANGLE, MARKNUMBERLINE.

'Dibujaremos los mismos objetos como en el Tutorial 2,
'  pero marcaremos algunos de ellos con sus nombres.
POINT A, 100,360, -1, &H0000FF
MARKPOINT A, -1, 2    'Tamao de letra predefinido; Posicin 2 = abajo.
POINT B, 400,360, -1, &H0000FF
MARKPOINT B, -1, 2
POINT C, 300,85, -1, &H0000FF
MARKPOINT C, 24       'Usamos un tamao de letra ms grande aqu.
a = LINE B,C
MARKLINE a, -1, 1     'Posicin: derecha - abajo
b = LINE A,C
MARKLINE b
c = LINE A,B
MARKLINE c, -1, 1     'Posicin: derecha - abajo

'Marcamos los ngulos del tringulo:
MARKANGLE B,A,C, "a"
MARKANGLE C,B,A, "b"
MARKANGLE A,C,B, "g", 24, 150   'Tamao de letra y radio del arco ms grandes.

hc = LINEPOLAR C, c, 90, &HF0F
MARKNUMBERANGLE c, hc, "f"
hb = LINEPOLAR B, b, 90, &HF0F
H = CROSS hc, hb, 4, &HFF0000

POINT X, 400, 280, -1, (0,128,0)
x, Y = STARTLINE X, 0, 180, -1, (0,128,0), 3

Z = ADVANCETO X, Y, 50, 2
MARKNUMBERLINE x, X,Z          'Marcamos la distancia X-Z.

z = LINEPOLAR Z, x, 30, -1, (0,128,0), 3

WAIT
END